# coding=utf-8
r"""
This code was generated by
\ / _    _  _|   _  _
 | (_)\/(_)(_|\/| |(/_  v1.0.0
      /       /
"""

from twilio.base.version import Version
from twilio.rest.studio.v1.flow import FlowList


class V1(Version):

    def __init__(self, domain):
        """
        Initialize the V1 version of Studio

        :returns: V1 version of Studio
        :rtype: twilio.rest.studio.v1.V1.V1
        """
        super(V1, self).__init__(domain)
        self.version = 'v1'
        self._flows = None

    @property
    def flows(self):
        """
        :rtype: twilio.rest.studio.v1.flow.FlowList
        """
        if self._flows is None:
            self._flows = FlowList(self)
        return self._flows

    def __repr__(self):
        """
        Provide a friendly representation

        :returns: Machine friendly representation
        :rtype: str
        """
        return '<Twilio.Studio.V1>'
